package edu.rpi.scheduler.schedb.spec;

/**
 *A PartOfTerm is a part of a larger term (think semester).
 *
 * At WPI we generally refer to our PartOfTerms as Terms.
 *
 * todo: Consider if we need start and end dates in here.
 * User: Peter
 * Date: Sep 19, 2007
 * Time: 4:09:38 PM
 */
public class PartOfTerm {
    //TODO: decide how to handle parts of parts of terms (subterms)
    //public Collection<SubTerm> getSubTerms();
    private final String identifier;
    private final String displayName;

	public PartOfTerm(String identifierAndName) {
        this(identifierAndName, identifierAndName);
    }
    public PartOfTerm(String identifier, String displayName) {
        this.identifier = identifier;
        this.displayName = displayName;
    }

    public String getIdentifier() { return identifier; }

    public String getDisplayName() { return displayName; }

    public boolean equals(Object obj) {
        if (!(obj instanceof PartOfTerm)) return false;
        if (obj == this) return true;

        return ((PartOfTerm) obj).getIdentifier().equals(getIdentifier());
    }

    public int hashCode() {
        return getIdentifier().hashCode();
    }
    
}
