package edu.rpi.scheduler.ui.panels.courses;

import edu.rpi.scheduler.ui.UITools;
import edu.rpi.scheduler.ui.panels.courses.CourseSelectionPanel.CourseRenderer;
import edu.rpi.scheduler.schedb.CourseDescriptor;

import javax.swing.*;
import java.awt.*;

/**
 * This is a little dot that reflects this course's availablity
 * for a specific PoT.
 */
public class DotPanel extends JPanel {
	private ImageIcon emptyIcon = loadIcon("empty.png");
	private ImageIcon openIcon = loadIcon("open.png");
	private ImageIcon chosenIcon = loadIcon("chosen.png");
	private ImageIcon impossibleIcon = loadIcon("impossible.png");

	private JPanel mainPanel;
	private JLabel myLabel;
	private CourseDescriptor cd = null;
	private SelectedCoursesList selectedCoursesModel = null;
	private ConflictDetector conflictDetector = null;

	public DotPanel(CourseDescriptor cd, SelectedCoursesList selectedCoursesModel, ConflictDetector conflictDetector) {
		this.cd = cd;
		this.selectedCoursesModel = selectedCoursesModel;
		this.conflictDetector = conflictDetector;
		
	}

	{
		/**
		 * This code sets up the object so it can be displayed
		 */
		setLayout(new BorderLayout());
		mainPanel = new JPanel();
		add(mainPanel);

		mainPanel.add(init());
	}

	
	private ImageIcon loadIcon(String name) {
			return new ImageIcon(CourseRenderer.class.getResource(name));
	}


	Icon icon;

	public JComponent init(){
		myLabel = new JLabel();


		if (icon != null) myLabel.setIcon(icon);

		myLabel.setVisible(true);
		myLabel.setText(" Hello");
		return myLabel;
	}

	public void setup(){
		boolean hasClass = UITools.hasClassTime(cd.getActualCourse());
		boolean chosen = selectedCoursesModel.containsCourse(cd);
		boolean impossible = !conflictDetector.couldBeAdded(cd);
		if(!hasClass) {
			icon = emptyIcon;
			setForeground(Color.LIGHT_GRAY);
		} else if (chosen) {
			icon = chosenIcon;
		} else if (impossible) {
			icon = impossibleIcon;
			setForeground(Color.LIGHT_GRAY);
		} else {
			icon = openIcon;
		}
	}

	public JComponent $$$getRootComponent$$$() {
		return mainPanel;
	}
}
