package edu.rpi.scheduler.ui.panels.listing;

import edu.rpi.scheduler.schedb.UniqueSection;
import edu.rpi.scheduler.schedb.CourseDescriptor;
import edu.rpi.scheduler.schedb.SectionDescriptor;
import edu.rpi.scheduler.ui.UITools;

import javax.swing.*;
import javax.swing.border.CompoundBorder;
import javax.swing.border.EmptyBorder;
import java.awt.*;
import java.util.*;

import com.intellij.uiDesigner.core.GridConstraints;
import com.intellij.uiDesigner.core.GridLayoutManager;

/**
 * This class is used to display one PartOfTerm worth of final class info in the listingPanel
 */
public class jlistWrapper extends JPanel{
	private JTextPane LocalTextPane;
	private String Term;
	private String PartOfTerm;
	private JPanel mainPanel;

	/**
	 * Constructor
	 * @param term String for the term this is representing
	 * @param PartOfTerm String for the PartOfTerm this is representing
	 */
	public jlistWrapper(String term, String PartOfTerm){
		this.Term = term;
		this.PartOfTerm = PartOfTerm;
	}
	{
		/**
		 * This code sets up the object so it can be displayed
		 */
		mainPanel = new JPanel();
		mainPanel.setLayout(new GridLayout(1,1));
		setLayout(new GridLayout(1,1));
		add(mainPanel);

		mainPanel.add(setupMainText());
	}

	public static int PLAIN;
	
	/**
	 * This sets up our main text pane and returns it so we can add it to our mainPanel.
	 * @return JComponent containing a JTextPane with default setup values.
	 */
	public JComponent setupMainText(){
		LocalTextPane = new JTextPane();
		LocalTextPane.setContentType("text/html");
		LocalTextPane.setFont(UITools.getLabelFont()); //doesnt seem to affect this...
		LocalTextPane.setBorder(new CompoundBorder(BorderFactory.createLineBorder(Color.lightGray), new CompoundBorder(
				BorderFactory.createLineBorder(Color.black), new EmptyBorder(10,10,10,10))));
		LocalTextPane.setText("<B>No Courses Selected for "+PartOfTerm+".</B>");
		LocalTextPane.setOpaque(true);
		LocalTextPane.setVisible(true);
        LocalTextPane.setEditable(false);


		return LocalTextPane;
	}

	/**
	 * This sets the text inside our main text area to refelct the given UniqueSections
	 * @param uss Collection of UniqueSection that should be displayed in this text area
	 */
	public void setSchedule(Collection<UniqueSection> uss){
		StringBuffer buf = new StringBuffer(1000);
		buf.append("<B style=\"color:blue\">"+ PartOfTerm +"</B><HR>");
		boolean firstSection = true;
		if(uss.isEmpty()) buf.append("<B>No Courses Selected for "+PartOfTerm+".</B>");

		for(UniqueSection us: uss){
			if(!firstSection) buf.append("<HR>");
			else firstSection = false;

			CourseDescriptor cd = us.getCourseDescriptor();
			buf.append("<B>Course: </B>" + cd.getActualCourse().getName() + "");
			Collection<SectionDescriptor> sds = us.getSectionDescriptors();
			java.util.List<SectionDescriptor> sorted = new ArrayList<SectionDescriptor>(sds);
			Collections.sort(sorted);
			if (sorted.size() > 1) {
				buf.append("<BR>");
				buf.append("<FONT STYLE=\"font-size: small;\">Sections ");
				UITools.getSectionNumberList(sorted, buf);
				buf.append(" share exactly the same weekly class time, <br>so you " +
						"can register for either of these: </FONT><BR>");
			} else {
				buf.append("<BR>");
			}
			boolean first = true;
			for (SectionDescriptor sd : sorted) {
				if (first) first = false;
				else buf.append("<BR>");
				buf.append("<B>Section: </B>" + sd.getActualSection().getNumber()
					+ " (" + sd.getActualSection().getID() + ")");
			}
		}
		LocalTextPane.setText(buf.toString());
	}

	public JComponent $$$getRootComponent$$$() {
		return mainPanel;
	}
}
